#include "stringFuncs.h"
#include <string.h>

static char hex2wc( BYTE hex )
{
	hex &= 0x0F;

	if ( hex >= 10 )
		return 'A' + ( hex - 10 );

	return '0' + hex;
}

static char *byte2hex( char *hexStr, const BYTE byte, const char cLast = ' ' )
{
	hexStr[0] = hex2wc( ( byte >> 4 ) );
	hexStr[1] = hex2wc( ( byte ) );
	hexStr[2] = cLast;
	hexStr[3] = '\0';

	return hexStr;
}

int bytes2string( char *str, int strSize, BYTE *bf, int bfSize, const char cSeparator )
{
	int len = 0;
	int pos = 0;
	
	char szSeparator[2] = " "; 
	if ( cSeparator == 0 )
		szSeparator[0] = '\0';
	else
		szSeparator[0] = cSeparator;

	for(; pos < bfSize; pos++ )
	{
		if ( len + 3 > strSize )
			break;

		char wcs[4]; // 4 wide char 'FF '
		byte2hex( wcs, bf[pos], szSeparator[0] );
#ifdef _WINDOWS
		strcpy_s( str + len, strSize - len, wcs );
#else
		strncpy( str + len, wcs, strSize - len );
#endif

		int addLen = strlen( str + len );
		len += addLen;
	}

	return pos;
}
