/////////////////////////////////////////////////////////////////
//
//	Copyright (c) 2015 Jetico Inc., Finland
//	All rights reserved.
//
//	File: hmac_funcs.h
//	Revision: 
//	Created:
//	Description: Hash-based message authentication code
//		There are two SHA1 and MD5 description. This version contains SHA1 realisation.
//
/////////////////////////////////////////////////////////////////

//
// Function: hmac_sha1
// Params:
//	unsigned char*  text;                pointer to data stream
//	int             text_len;            length of data stream
//	unsigned char*  key;                 pointer to authentication key
//	int             key_len;             length of authentication key
//	unsigned char*  digest;              caller digest to be filled in
//
// Returns 0 if success.
//
int hmac_sha1(const unsigned char *text, int text_len,
	       const unsigned char *key, int key_len,
	       unsigned char *digest);

//
// Function: hmac_sha1_autotest
// Returns 0 if success.
//
int hmac_sha1_autotest();